#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern byte[] Backup;

static const byte[] ColorSource = {
    Char_Logo, 25, 0x05,
    Char_Ladder_Left, 2, 0x06,
    Char_Monster, 32, 0x03,
    Char_Item, 4, 0x06,
    0xff
};

byte[256] CharColors;

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}

void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x07;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
}


void ClearScreen()
{
    *((ptr<byte>)0xe890) = 0x07;
    FillMemory(Vram, VramRowSize * VramHeight, 0);
    FillMemory(Text, VramWidth * VramHeight, 0);
    FillMemory(Backup, VVramWidth * VVramHeight, 0);
    ClearRowFlags();
}


void VPut2C(ptr<byte> pVram, ptr<byte> pText, byte c)
{
    repeat (2) {
        repeat (2) {
            VPut(pVram, pText, c);
            ++pVram;
            ++pText;
            ++c;
        }
        pVram += VramRowSize - 2;
        pText += VramWidth - 2;
    }
}
