include "Vram.inc"
include "VVram.inc"

ext @Temp@Word
ext @Temp@Word2
ext @Temp@Word3
ext @Temp@Word4
ext @Temp@Word5

ext @Temp@Byte
ext @Temp@Byte2
ext @Temp@Byte3
ext @Temp@Byte4
ext @Temp@Byte5

ext VVramFront_, RowFlags_
ext ClearRowFlags_
ext Chars_
ext CharColors_

pVram equ @Temp@Word
pChars equ @Temp@Word2
vCount equ @Temp@Byte
hCount equ @Temp@Byte2
pText equ @Temp@Word3
pVVram equ @Temp@Word4
pBackup equ @Temp@Word5

flags equ @Temp@Byte4
maskBit equ @Temp@Byte5

dseg
Backup_: public Backup_
    defs VVramWidth*VVramHeight
pflags:
    defw 0


cseg
SetColor:
    ldx #CharColors_
    staa SetColor_offset+1
    SetColor_offset:
    ldab 0,x
    stab ColorPort
rts

VPut: public VPut
    staa <pChars+1 | clr <pChars
    asl <pChars+1 | rol <pChars ;*2
    asl <pChars+1 | rol <pChars ;*4
    asl <pChars+1 | rol <pChars ;*8
    ldab <pChars+1 | addb #low Chars_ | stab <pChars+1
    ldab <pChars | adcb #high Chars_ | stab <pChars
VPut_trans: public VPut_trans
    clr VPut_offset+1
    do
        ldx <pChars | ldab 0,x | inx | stx <pChars
        ldx <pVram
        
        VPut_offset:
        stab 0,x

        ldab VPut_offset+1 | addb #VramWidth | stab VPut_offset+1
    while ne | wend
rts


; void VPut(ptr<byte> <pVram, ptr<byte> pText, byte c);
dseg
    VPut_@Param0: public VPut_@Param0
    VPut_pVram: defw 0
    VPut_@Param1: public VPut_@Param1
    VPut_pText: defw 0
    VPut_@Param2: public VPut_@Param2
    VPut_c: defb 0
cseg
VPut_: public VPut_
    psha | pshb
        ldaa VPut_c
        bsr SetColor
        ldx VPut_pText | clr 0,x
        ldx VPut_pVram | stx <pVram
        bsr VPut
    pulb | pula
rts


; ptr<byte> PrintC(ptr<byte> <pVram, byte c);
dseg
    PrintC_@Param0: public PrintC_@Param0
    PrintC_pVram: defw 0
    PrintC_@Param1: public PrintC_@Param1
    PrintC_c: defb 0
cseg
PrintC_: public PrintC_
    psha | pshb
        ldaa #7 | staa ColorPort
        ldx PrintC_pVram | stx <pVram
        ldaa PrintC_c
        suba #$20
        staa <pChars+1 | clr <pChars
        asl <pChars+1 | rol <pChars ;*2
        asl <pChars+1 | rol <pChars ;*4
        asl <pChars+1 | rol <pChars ;*8
        ldab <pChars+1 | addb #low Chars_ | stab <pChars+1
        ldab <pChars | adcb #high Chars_ | stab <pChars
        bsr VPut_trans
        ldx PrintC_pVram | inx
    pulb | pula
rts


VVramToVramInit:
    ldx #VVramFront_+VVramWidth | stx <pVVram
    ldx #Backup_ | stx <pBackup
    ldx #Vram+VramRowSize*2 | stx <pVram
    ldx #Text+VramWidth*2 | stx pText
rts

VVramToVramRow: public VVramToVramRow
    ldaa #VVramWidth
    staa <hCount
    do
        ldx <pVVram | ldaa 0,x
        ldx <pBackup | cmpa 0,x
        if ne
            staa 0,x
            bsr SetColor
            bsr VPut
            ldx pText | clr 0,x
        endif
        VVramToVramRow_next:
        ldx <pVVram | inx | stx <pVVram
        ldx <pBackup | inx | stx <pBackup
        ldx <pVram | inx | stx <pVram
        ldx pText | inx | stx pText
        dec <hCount
    while ne | wend

    ldaa <pVram+1 | adda #low (VramRowSize-VVramWidth) | staa <pVram+1
    ldaa <pVram | adca #high (VramRowSize-VVramWidth) | staa <pVram

    ldaa pText+1 | adda #low (VramWidth-VVramWidth) | staa pText+1
    ldaa pText | adca #high (VramWidth-VVramWidth) | staa pText
rts


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    psha | pshb
        bsr VVramToVramInit
        ldaa #VVramHeight-2 | staa <vCount
        do
            bsr VVramToVramRow
            dec <vCount
        while ne | wend
        jsr ClearRowFlags_
    pulb | pula
rts


; void VVramToVramChanged();
cseg
VVramToVramChanged_: public VVramToVramChanged_
    psha | pshb
        ldx #RowFlags_ | stx pflags
        ldaa 0,x | staa <flags
        ldaa #2 | staa <maskBit

        bsr VVramToVramInit
        ldaa #VVramHeight-2 | staa <vCount
        do
            ldaa <flags
            anda <maskBit
            if ne
                bsr VVramToVramRow
            else
                ldaa <pVVram+1 | adda #low VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #high VVramWidth | staa <pVVram

                ldaa <pBackup+1 | adda #low VVramWidth | staa <pBackup+1
                ldaa <pBackup | adca #high VVramWidth | staa <pBackup

                ldaa <pVram+1 | adda #low VramRowSize | staa <pVram+1
                ldaa <pVram | adca #high VramRowSize | staa <pVram

                ldaa pText+1 | adda #low VramWidth | staa pText+1
                ldaa pText | adca #high VramWidth | staa pText
            endif
            asl <maskBit
            if eq
                ldx pflags | inx | stx pflags
                ldaa 0,x | staa <flags
                ldaa #1 | staa <maskBit
            endif
            dec <vCount
        while ne | wend
        jsr ClearRowFlags_
    pulb | pula
rts
